summary | shortlog | log | commit | commitdiff | tree
raw | patch | inline | side by side (parent: 09ff69b)
raw | patch | inline | side by side (parent: 09ff69b)
author | Johannes Schindelin <Johannes.Schindelin@gmx.de> | |
Wed, 4 Jul 2007 14:36:01 +0000 (15:36 +0100) | ||
committer | Junio C Hamano <gitster@pobox.com> | |
Fri, 6 Jul 2007 05:16:28 +0000 (22:16 -0700) |
A common mistake is to provide a filter which fails unwantedly. For
example, this will stop in the middle:
git filter-branch --env-filter '
test $GIT_COMMITTER_EMAIL = xyz &&
export GIT_COMMITTER_EMAIL = abc' rewritten
When $GIT_COMMITTER_EMAIL is not "xyz", the test fails, and consequently
the whole filter has a non-zero exit status. However, as demonstrated
in this example, filter-branch would just stop, and the user would be
none the wiser.
Also, a failing msg-filter would not have been caught, as was the
case with one of the tests.
This patch fixes both issues, by paying attention to the exit status
of msg-filter, and by saying what failed before exiting.
Signed-off-by: Johannes Schindelin <johannes.schindelin@gmx.de>
Signed-off-by: Junio C Hamano <gitster@pobox.com>
example, this will stop in the middle:
git filter-branch --env-filter '
test $GIT_COMMITTER_EMAIL = xyz &&
export GIT_COMMITTER_EMAIL = abc' rewritten
When $GIT_COMMITTER_EMAIL is not "xyz", the test fails, and consequently
the whole filter has a non-zero exit status. However, as demonstrated
in this example, filter-branch would just stop, and the user would be
none the wiser.
Also, a failing msg-filter would not have been caught, as was the
case with one of the tests.
This patch fixes both issues, by paying attention to the exit status
of msg-filter, and by saying what failed before exiting.
Signed-off-by: Johannes Schindelin <johannes.schindelin@gmx.de>
Signed-off-by: Junio C Hamano <gitster@pobox.com>
git-filter-branch.sh | [changed mode: 0644->0755] | patch | blob | history |
t/t7003-filter-branch.sh | patch | blob | history |
diff --git a/git-filter-branch.sh b/git-filter-branch.sh
--- a/git-filter-branch.sh
+++ b/git-filter-branch.sh
fi
}
+# override die(): this version puts in an extra line break, so that
+# the progress is still visible
+
+die()
+{
+ echo >&2
+ echo "$*" >&2
+ exit 1
+}
+
# When piped a commit, output a script to set the ident of either
# "author" or "committer
export GIT_COMMIT=$commit
git cat-file commit "$commit" >../commit
- eval "$(set_ident AUTHOR <../commit)"
- eval "$(set_ident COMMITTER <../commit)"
- eval "$filter_env" < /dev/null
+ eval "$(set_ident AUTHOR <../commit)" ||
+ die "setting author failed for commit $commit"
+ eval "$(set_ident COMMITTER <../commit)" ||
+ die "setting committer failed for commit $commit"
+ eval "$filter_env" < /dev/null ||
+ die "env filter failed: $filter_env"
if [ "$filter_tree" ]; then
git checkout-index -f -u -a
# files that $commit removed are now still in the working tree;
# remove them, else they would be added again
git ls-files -z --others | xargs -0 rm -f
- eval "$filter_tree" < /dev/null
+ eval "$filter_tree" < /dev/null ||
+ die "tree filter failed: $filter_tree"
+
git diff-index -r $commit | cut -f 2- | tr '\n' '\0' | \
xargs -0 git update-index --add --replace --remove
git ls-files -z --others | \
xargs -0 git update-index --add --replace --remove
fi
- eval "$filter_index" < /dev/null
+ eval "$filter_index" < /dev/null ||
+ die "index filter failed: $filter_index"
parentstr=
for parent in $parents; do
done
done
if [ "$filter_parent" ]; then
- parentstr="$(echo "$parentstr" | eval "$filter_parent")"
+ parentstr="$(echo "$parentstr" | eval "$filter_parent")" ||
+ die "parent filter failed: $filter_parent"
fi
sed -e '1,/^$/d' <../commit | \
- eval "$filter_msg" | \
- sh -c "$filter_commit" "git commit-tree" $(git write-tree) \
- $parentstr > ../map/$commit
+ eval "$filter_msg" > ../message ||
+ die "msg filter failed: $filter_msg"
+ sh -c "$filter_commit" "git commit-tree" \
+ $(git write-tree) $parentstr < ../message > ../map/$commit
done <../revs
src_head=$(tail -n 1 ../revs | sed -e 's/ .*//')
[ -f "../map/$sha1" ] || continue
new_sha1="$(cat "../map/$sha1")"
export GIT_COMMIT="$sha1"
- new_ref="$(echo "$ref" | eval "$filter_tag_name")"
+ new_ref="$(echo "$ref" | eval "$filter_tag_name")" ||
+ die "tag name filter failed: $filter_tag_name"
echo "$ref -> $new_ref ($sha1 -> $new_sha1)"
index 451ac861af21fb74bbb1c52dff23c359bfb1844a..4ddd656e847e90e8f9f373e40dc41c39809d816f 100755 (executable)
--- a/t/t7003-filter-branch.sh
+++ b/t/t7003-filter-branch.sh
mv \$GIT_INDEX_FILE.new \$GIT_INDEX_FILE" directorymoved &&
test -z "$(git diff HEAD directorymoved:newsubdir)"'
+test_expect_success 'stops when msg filter fails' '
+ ! git-filter-branch --msg-filter false nonono &&
+ rm -rf .git-rewrite &&
+ ! git rev-parse nonono
+'
+
test_expect_success 'author information is preserved' '
: > i &&
git add i &&
test_tick &&
GIT_AUTHOR_NAME="B V Uips" git commit -m bvuips &&
git-filter-branch --msg-filter "cat; \
- test \$GIT_COMMIT = $(git rev-parse master) && \
+ test \$GIT_COMMIT != $(git rev-parse master) || \
echo Hallo" \
preserved-author &&
test 1 = $(git rev-list --author="B V Uips" preserved-author | wc -l)